input:not([type=checkbox]):not([type=radio]),
textarea,
select {
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
}

input, textarea {
    outline: none;
    &:focus:required:invalid { border-color: red }
    &:required:valid { border-color: green }
}

option::selection {background: #ccc;}
option::-moz-selection {background: #ccc;}
option::-webkit-selection {background: #ccc; color:#fff;}

.field {
    display: block;
    border-radius: 5px;
    position: relative;
    background: #ECECEC;
    $input-selector: "input[type=text], input[type=email], input[type=password], textarea, select";

    #{$input-selector} {
        margin: 0;
        width: 100%;
        z-index: 10;
        height: rem(30);
        outline: none;
        color: $dark;
        box-shadow: none;
        font-weight: 400;
        position: relative;
        border-radius: 5px;
        font-size: rem(14);
        line-height: rem(20);
        padding: rem(4) rem(12);
        background: transparent;
        display: inline-block;
        vertical-align: middle;
        border: rem(1) solid #ECECEC;
        @include placeholder(#929292);

        &::-ms-clear {
            display: none;
            width: 0;
            height: 0;
        }

        &:focus,
        &:active {
            outline: none;
            border-color: $dark;
            @include placeholder(transparent);
        }


        &.error {
            border-color: red !important;
        }
    }

    textarea {
        height: auto;
        resize: none;
    }

    select {
        -moz-appearance: none;
        -webkit-appearance: none;
        appearance: none;
        padding-right: rem(28);
        background-image: url(data:image/svg+xml;base64,PHN2ZyB3aWR0aD0iMTEiIGhlaWdodD0iOSIgdmlld0JveD0iMCAwIDExIDkiIGZpbGw9Im5vbmUiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyI+CjxwYXRoIGQ9Ik01LjUgOUwwLjczNjg2IDAuNzUwMDAxTDEwLjI2MzEgMC43NUw1LjUgOVoiIGZpbGw9IiM2NTY1NjUiLz4KPC9zdmc+Cg==);
        background-repeat: no-repeat;
        background-position: right .5rem top 50%, 0 0;

        &::-ms-expand { display: none; }
    }

    &__icon {
        top: rem(7);
        left: rem(10);
        z-index: 1;
        font-size: 0;
        line-height: 0;
        height: rem(16);
        fill: #929292;
        position: absolute;
        display: inline-block;
    }

    &__counter {
        z-index: 1;
        left: rem(24);
        bottom: rem(14);
        color: #6C6C6C;
        position: absolute;
        font-size: rem(14);
        line-height: rem(21);
    }

    &--icon {

        #{$input-selector} {
            padding-left: rem(30);
        }
    }

    &--white {
        background: transparent;

        #{$input-selector} {
            border: 1px solid #D9D9D9;
        }
    }

    &--md {
        top: rem(11);

        #{$input-selector} {
            height: rem(48);
            font-size: rem(16);
            line-height: rem(28);
            padding: rem(9) rem(22);
        }

        select {
            padding-left: rem(48);
            padding-right: rem(32);
        }

        textarea {
            height: auto;
            padding: rem(9) rem(22) rem(9) rem(22);
        }

        .field--icon {

            #{$input-selector} {
                padding-left: rem(50);
            }
        }

        .field {

            &__icon {
                top: rem(9);
                left: rem(12);
                height: rem(28);
            }
        }
    }

    &--xl {

        #{$input-selector} {
            height: rem(56);
            font-weight: 500;
            font-size: rem(19);
            padding: rem(13) rem(22);
        }
    }

    &--counter {

        textarea {
            padding-bottom: rem(48);
        }
    }

    &.error {

        #{$input-selector} {
            border-color: #FF2E2C;
        }
    }
}
